fDEVELOPER EQU 1 ;=0 for freeware edition. =1 for Web Edition.
sEVEVERSION TEXTEQU <"3.56"> ;keep updated latest EVE version.

 ;v1.51 ... will now have W.E. for svg code.
 ;note, need to set fDEVELOPER in eve.rc file also.

NEXTRAWIDTH EQU 8	;used to stop wires from jumping out rings.

;the general structure of all objects...
;NOTE all pointers are relative to start of TERSEDATA.
;When appl running, pTERSEDATA will have addr of start TERSEDATA.
bez0x	   EQU xtopleft
bez0y	   EQU ytopleft
bez3x	   EQU xknee2
bez3y	   EQU yknee2
bez4x	   EQU xmid
bez4y	   EQU ymid
bez5x	   EQU xknee3
bez5y	   EQU yknee3
bez8x	   EQU wwidth
bez8y	   EQU height
bez9x	   EQU xdiffnorm1st  ;poly only here-on...
bez9y	   EQU ydiffnorm1st
bez10x	   EQU xdiffnorm2nd
bez10y	   EQU ydiffnorm2nd
bez11x	   EQU narrowscaling1st
bez11y	   EQU narrowscaling2nd
bez12x	   EQU xlabeloffset
bez12y	   EQU ylabeloffset
bez13x	   EQU xdeltacentre
bez13y	   EQU ydeltacentre
sztext	   EQU rpmethods ;start of data in data-element.
ncornerwidth EQU bez1x	 ;for rounded rectangle.
ncornerheight EQU bez1y  ; /
ncorners   EQU narrow1st   ;# corners for polygon.
NCORNERSMAX14 EQU 14  ;maximum # corners allowed for polygon/line.(before v2.01).
nbeginverticex EQU narrow1st ;which poly-vertice attached-to, label/icon.
rpdata2    EQU rpowner2
nshape	   EQU rpowner2
;ximage    EQU rpmaster
widthhimetric EQU bez7x   ;icons: width/height in himetric units.
heighthimetric EQU bez7y  ;/
widthtext	  EQU bez6x   ;labels.	width/height of text.
heighttext	  EQU bez6y   ;/
szfontname EQU nbeginvertice ;label/icon: 32-byte field, name of font.
ncharset   EQU narrow2nd ;label/icon stores charactet set # here.
displayscale EQU narrowscaling1st ;icon: scaling factor % for displaying bitmap. <<v1.85 NOT USED.
marginleft	 EQU xknee3 ;bez5x grid: svg margins.
margintop	 EQU yknee3 ;bez5y		   /
marginright  EQU xdiffnorm2nd ;bez10x  /
marginbottom EQU ydiffnorm2nd ;bez10y  /
arrow2ndx2	 EQU nfontstyle
arrow2ndy2	 EQU nfontsize
arrow2ndx3	 EQU nfonttype
arrow2ndy3	 EQU nfontangle
anitime 	 EQU narrowscaling2nd	;v1.59
cntani		 EQU xdiffnorm2nd		;v1.59
maxcntani	 EQU ydiffnorm2nd		;v1.59
origwidth	 EQU bez2x				;v1.85
origheight	 EQU bez2y				;/
charheight EQU yknee3  ;v2.55
charascent EQU xknee3  ;v2.63.
rgbtransparent EQU narrowscaling2nd ;v2.90.
rxstartarc EQU bez6x  ;v2.98.
rystartarc EQU bez6y  ;/
rxendarc   EQU bez7x  ;/
ryendarc   EQU bez7y  ;/
xenderror  EQU bez7x  ;v3.14.
yenderror  EQU bez7y  ;/
pagewidth  EQU xknee2 ;v3.42
pageheight EQU yknee2 ;/

;* WARNING, code only manipulates lower 8 bits -- leave higher bits 0.
;** WARNING, code only manipulates lower 16 bits - leave higher bits 0.
OBJECT STRUCT
fstatus 	DWORD	0	;0 bit0=0 invalid object,bit0=1 valid.	 was BYTE*
nexttype	DWORD	0	;4 sub-type of obj -1=data-element ;was WORD**
xdata		DWORD	0	;8 type/size of data held by additional data.
rpdata		DWORD	0	;12 -->additional data.(in object database)
ximage		DWORD	0	;16 bitmap dataelement: handle to IPicture interface.
						;category dataelement: handle to popup submenu. v1.31
rpowner1 	DWORD	0	;20 owner of this object.(wire: 1st end).
rpowner2 	DWORD	0	;24 wire:owner of 2nd end. node: .rpdata2(->bitmaps)
						;bitmap dataelement: .nshape, *NOT* used as ptr in dataelement.
						;(normal elements use .rpdata, .rpowner1, .rpowner2 as ptrs,
						; dataelements only use .rpdata and .rpowner1 as ptrs).
;null or data objects can have data past here (260 bytes)...

rpmethods	DWORD	0	;28 -->methods. data:.sztext
	;...relative to "ptrs", which is start of the methods.
number		DWORD	1	;number, starting from 1, of this object.;was WORD
fconfig0	DWORD	0	;
fconfig1	 DWORD	 0	 ;0=node,1=wire (see exttype also). ;was BYTE*
fconfig2	DWORD	0	;44 				  ;was BYTE*
fconfig3	DWORD	0	;48
fconfig4	DWORD	0	;52
flinks 	  DWORD	0	;56
spare11 	DWORD	0	;60    17 fields up to here
morphingwidth	DWORD	0	;*all* elements. v3.40

;object coordinates...
xtopleft	SDWORD	0	;all:.xtopleft. wire/poly:bex0x.
ytopleft	SDWORD	0	;all:.ytopleft. wire/poly:bez0y.
bez1x		SDWORD	0	;wire/poly:.bez1x. rect:.ncornerwidth for rounded-rect (and used icon, etc).
bez1y		SDWORD	0	;wire/poly:.bez1y. rect:.ncornerheight /
bez2x		SDWORD	0	;wire/poly:.bez2x. Grid:.xfineprn. icon:.origwidth.
bez2y		SDWORD	0	;wire/poly:.bez2y. Grid:.yfineprn. icon:.origheight.
xknee2	SDWORD	0	;wire:.xknee2, wire/poly:.bez3x. node:.xdeltacentre. grid:pagewidth.
yknee2	SDWORD	0	;wire:.yknee2. wire/poly:.bez3y.	node:.ydeltacentre.grid:pageheight.
xmid		SDWORD	0	;all:.xmid,absolute middle coords. wire/poly:.bez4x.
ymid		SDWORD	0	;all:.ymid,absolute middle coords. wire/poly:.bez4y.
xknee3	SDWORD	0	;wire:3rd knee. wire/poly:.bez5x. grid:.marginleft label:.charascent
yknee3	SDWORD	0	;wire:3rd knee. wire/poly:.bez5y. grid:.margintop label:.charheight
bez6x		SDWORD	0	;label:.widthtext.     wire/poly:.bez6x. node:.rxstartarc.
bez6y		SDWORD	0	;label:.heighttext.    wire/poly:bez6y.  node:.rystartarc.
bez7x		SDWORD	0	;icon:.widthhimetric.  wire/poly:.bez7x. node:.rxendarc. activator:.xenderror
bez7y		SDWORD	0	;icon:.heighthimetric. wire/poly:.bez7y. node:.ryendarc. activator:.yenderror
wwidth		SDWORD	0	;node:.wwidth. wire/poly:.bez8x, wire:.wwidth,destination.
height		SDWORD	0	;node:.height. wire/poly:.bez8y, wire:.height,destination.
xdiffnorm1st SDWORD 0	;wire:.xdiffnorm1st,arrow. poly: bez9. *careful*used by all
ydiffnorm1st SDWORD 0	;wire:.ydiffnorm1st,arrow. poly:.bez9y. *careful*elements state4.
xdiffnorm2nd SDWORD 0	;wire:.ydiffnorm2nd,arrow. poly:.bez10x. grid:.marginright  activator:cntani
ydiffnorm2nd SDWORD 0	;wire:.ydiffnorm2nd,arrow. poly:.bez10y. grid:.marginbottom activator:maxcntani
narrowscaling1st SDWORD 0 ;wire. poly: bez11x. icon:displayscale.
narrowscaling2nd SDWORD 0 ;wire. poly:bez11y. activator:anitime. icon:rgbtransparent.
xlabeloffset SDWORD 0	;label/icon:.xlabeloffset. poly:.bez12x. used by activator.
ylabeloffset SDWORD 0	;label/icon:.ylabeloffset. poly:.bez12y. used by activator.
xdeltacentre SDWORD 0	;node:offset for rings.	poly:.bez13x. used by activator.
ydeltacentre SDWORD 0	;node:offset for rings.	poly:.bez13y. used by activator.

nrings		DWORD	1	;number of rings(default 1). 	
nringwidth	SDWORD	0	;
nbeginring	DWORD	1	;Wire:ring# on parent-obj that 1stendwirelockedto. *Other elements may have 1 here*.
nendring	DWORD	1	;Wire: ring# on parent-obj that dest.end lockedto.
spare30   DWORD	0	;(was .nchildren, earlier databases, so may be non0).
ffonteffects DWORD	0 ;text special effects (bit0=strikethru, bit1=underline)

nfillcolor	DWORD	0	;180 brush colour to fill element.
nfillstyle	DWORD	0	;184
npencolor	DWORD	0	;188 pen colour for element.
npenwidth	DWORD 0 ;192 pen width.
npenstyle	DWORD	0 ;196

nfontcolor	DWORD 0  ;200
nfontstyle	DWORD 0  ;wire:.arrow2ndx2		bold, italic,
nfontsize	DWORD 0  ;wire:.arrow2ndy2		size of text.
nfonttype	DWORD 0  ;wire:.arrow2ndx3		type (name) of font (Times, Arial, etc). =3, see name below.
nfontangle DWORD 0	 ;wire:.arrow2ndy3	label/icon:angle of font.

narrow1st DWORD 0	; .ncorners --polygons. .nbeginverticex for label/icon element (see below).
narrow2nd DWORD 0	; .ncharset --label/icon.
nlibrary DWORD	 0	 ; index to embedded graphic bitmap.
nbeginvertice DWORD 0 ; any obj, or 1st-end-wire, which vertice of poly attached to.  label/icon: .szfontname
nendvertice DWORD	0 ; 2nd-end-wire, which vertice of poly attached to. (0=automatic)	label/icon: /

arrow1stx2	 DWORD 0 ;wire:vertice for arrowhead.										label/icon: /
arrow1sty2	 DWORD 0 ;wire:vertice for arrowhead.										label/icon: /
arrow1stx3	 DWORD 0 ;wire:vertice for arrowhead.										label/icon: /
arrow1sty3	 DWORD 0 ;wire:vertice for arrowhead.										label/icon: /

spare50   DWORD 0 ; 									  label/icon: /
end01   DWORD 0 ; 		label/icon:end of .szfontname (32 bytes)  /
;...for data elements, end01 is available after the 256 bytes of data, used by
;data elements for various purposes.
;...total size 260+32 =288 bytes.
OBJECT ENDS

;normal data-elements (.nexttype=-1)...
;.rpdata non-0 means a data-element attached, with .fdata specifying
;type of data. In the data-element, .rpdata and .fdata can specify
;another chained data-element.	.rpowner1->immediate owner
;(which may be a data-element if they are chained).
;v1.31 library dataelements (.nexttype=FFFFC000h) can have .rpdata ptg to a
;category dataelement (.nexttype=FFFFE000h).
;note, .rpowner2 is NOT used as a pointer in a data element.
;data elements have .nexttype=-1 or FFFFC000h or FFFFE000h, or more --
; i.e. guaranteed to have bits14-31 set.
;(note, library composite-object elements have bits 15-31 set, bit14 clr, rest same as before).
;v1.31 submenu data element: .nexttype=FFFFE000h, bits13-31 set.
;so, to test for *all* data elements:
;						 mov eax,(OBJECT PTR [esi]).nexttype
;						 and eax,0FFFFC000h
;						 .IF eax==0FFFFC000h ;gets all data elements.
;To test for *all* invisible elements, which is dataelements and library objects:
;		  mov eax,(OBJECT PTR [esi]).nexttype
;		  .IF SDWORD PTR eax<0	or: .IF SWORD PTR ax<0


;##################################################################
;this is the database. it has this format in the disk data file.
;the object-database is variable size.
;The complete TERSEDATA is a default template for a new data file,
;and everything here is copied to memory block.
NUMINITOBJS EQU 10		 ;note, also defined in eve_c.c
NCURRENTVERSION EQU 11 ;(GOOSEE used 10).
templatestart EQU feveprefs ;xfinescrn ;here to templateend overlaid by import template. v3.31
templateend EQU future10

TERSEDATA STRUCT
nsignature	 DWORD 0	;integrity check for database.(must be first).
nversion	 DWORD NCURRENTVERSION			;
nsizeobject  DWORD (SIZEOF OBJECT)	 ;was WORD
numrecords	 DWORD NUMINITOBJS	;number of records in database.
				;(TOTAL, including data and invalid objects)
xleft		 SDWORD 0		;	read-only, current top/left window.
ytop		 SDWORD 0		;	  /
xright	  SDWORD 0		; maybe bot/right coords of window?
ybot	  SDWORD 0		; /
nzoom		 SDWORD 0 ;was SBYTE 0;=0 normal, <0 in, >0 out.
hwindow1	 DWORD 0		;
nproject	 DWORD 0 ;was WORD 0;number of the current diagram/project.
nsubproject  DWORD 0 ;was WORD 0;number of current sub-diagram/project.
noffsetobjs DWORD 0 ;offset of OBJECTS from start of TERSEDATA.
numbitmaps	  DWORD 0	   ;number of embedded gif/jpg bitmap files.
numlibrary	  DWORD 0	   ;number of composite-objects in library.
future4    DWORD 0		;
future5    DWORD 0
future6    DWORD 0
feveprefs	 DWORD 0 ;was BYTE	;.templatestart equates to here.	   x
fviewprefs	 DWORD 0 ;was BYTE	;									                 x
wszeditor1	 BYTE 256 DUP(0) ;"WORDPAD.EXE",0  ;v3.01 REMOVED			 x
arraycolors DWORD 16 DUP(0) ;custom colors in color-picker dlgbox. x
charsetdefault DWORD 0		;                                        x
xfinescrn	 SDWORD 0		 ;                                           x
yfinescrn	 SDWORD 0		 ;                                           x
xfineprn	 SDWORD 0		 ;                                           x
yfineprn	 SDWORD 0		 ;                                           x
nbackground  DWORD	0		 ;diagram background color (0-3).          x
wszeditor2  BYTE 256 DUP(0) ;"NOTEPAD.EXE",0 ;v2.31 v3.01 REMOVED  x
wszbrowser2 BYTE 256 DUP(0) ;alternative browser. v3.01 REMOVED    x
wszpainter1 BYTE 256 DUP(0) ;"MSPAINT.EXE",0    ;v3.01 REMOVED     x
nhandleradius DWORD 2 ;radius of handles, in pixels. v3.31         x

future10 BYTE 3284 DUP(0)	;.templateend --ends at end previous field.

OBJECTS OBJECT NUMINITOBJS DUP(<>)

TERSEDATA ENDS
;##################################################################
;(objects are instantiated after TERSEDATA).



;these (arbitrary) equates could have been in an include file...

;File menu ...
IDM_NEW 		EQU 485
IDM_OPEN		EQU 107
IDM_TEMPLATE	EQU 500
IDM_MERGE		EQU 501
IDM_SAVE		EQU 108
IDM_SAVEAS		EQU 109
IDM_ERASEDIA	EQU 361
IDM_PRA 	EQU 131
IDM_CPY 	EQU 165
IDM_QUIT	EQU 100
IDM_PSET	EQU 254  ;printer setup.
IDM_DUP 	EQU 502
IDM_SAVEASS EQU 510
IDM_SAVEASS_EMF EQU 511
IDM_SAVEASS_WMF EQU 253
IDM_EMBEDDED	EQU 124
IDM_LIB 	EQU 125
IDM_BITMAP	 EQU 118
IDM_LASTOPEN EQU 600
IDM_SAVEASS_SVG EQU 482
IDM_SAVEASALLSVG EQU 465 ;v3.07

;Objects menu ...
IDM_NODE	EQU 102 ;*EVE*
IDM_RES EQU 110 	 ;*EVE*
IDM_RESR EQU 166
IDM_POLY EQU 128
IDM_WIRE	 EQU 103 ;*EVE*
IDM_VECTOR		EQU 122 ;*EVE*
IDM_MULTI		EQU 123 ;*EVE*
IDM_EVEICON 	EQU 126 ;*EVE*
IDM_GENERICICON   EQU 117 ;/
IDM_WWWICON    EQU	 121 ;/
IDM_SOUNDICON	 EQU   120 ;/
IDM_SYNC2	EQU 104 ;*EVE*
IDM_ASYNC2	EQU 497
;IDM_GENERIC  EQU	119
IDM_COMMANDICON EQU 504
IDM_INFOICON	EQU 505
IDM_GRID		EQU 484
IDM_BEZIER		EQU 483
IDM_ACTIVA		EQU 481
IDM_ALIGNAXES	EQU 475 ;v1.97.
IDM_IMPORT_SVG	EQU 473 ;v2.01.
IDM_UVECTOR 	EQU 468 ;v2.27.
IDM_LINK      EQU 467 ;v2.76.
IDM_NODEP   EQU 466 ;v2.96.
IDM_INLINE EQU 464 ;v3.25.

;Control menu ...
IDM_ZOOMNORM	EQU 116
IDM_ZOOMOUT EQU 114
IDM_ZOOMIN	EQU 115
IDM_ORIGIN	EQU 164
IDM_SELALL	EQU 163
IDM_PROJECT EQU 161
IDM_TOOLBOX EQU 160
;IDM_GENINSERT	EQU 182
;IDM_OS 	EQU 183
IDM_ABOUT	EQU 101
IDM_PREFS	EQU 184
IDM_TFIND	EQU 255
IDM_NFIND	EQU 256
IDM_RECT	EQU 507
IDM_MOVE	EQU 508
IDM_DELS	EQU 509
IDM_ABOUTWE EQU 480 ;v1.83.
IDM_RESIZESEL	EQU 479 ;v1.92.
;IDM_RESIZEST	 EQU 478 ;v1.94.
IDM_FLIPH		EQU 477 ;/
IDM_FLIPV		EQU 476 ;/
IDM_STRETCHSEL	EQU 474 ;v1.98.
IDM_ROT90		EQU 469 ;v2.21.

;PROJECT management dialog box... (id=201)
IDD_PROJNUM    EQU	204
IDD_PROJSUBNUM EQU	205
IDD_DBASEVER   EQU	206

;Operating System dialog box (id=202)
IDD_OS1 	   EQU 204	;service for sync 1-way
IDD_OS2 	   EQU 205	;service for sync 2-way
IDD_OS3 	   EQU 206	;service for async 1-way
IDD_OS4 	   EQU 207	;service for async 2-way
IDD_OSQUAL1    EQU 208	;/
IDD_OSQUAL2    EQU 209	;/
IDD_OSQUAL3    EQU 210	;/
IDD_OSQUAL4    EQU 211	;/

;KENTER5 box...
;/*select font size...*/
K2F1   EQU 210
K2F15  EQU 211
K2F2   EQU	212
K2F4   EQU	213
;node fill color...*/
K5FC   EQU 220
K5NF   EQU 221
K5CF   EQU 222
;display node number...*/
KDNN   EQU 230
KDNONE EQU 231
;/* more stuff...*/
KXOFF  EQU 240
KYOFF  EQU 241
KSPEC  EQU 242
KSPF   EQU	243
KSPC   EQU	244
KSPD   EQU	245
KSPA   EQU	246
IDD_K5PU  EQU	302
IDD_INVIS EQU	303
IDM_RSUB  EQU	105
IDD_REPLYTYPE EQU	306
IDD_K2CHK1 EQU		109
Kobjnum EQU 250
IDD_K2LABEL EQU 	102

;IDM_CONDITION EQU 251
IDM_label EQU 252
IDM_1CODE	  EQU 253

IDM_INTEGRITY EQU 257

;bind interface...
IDM_BIND_LEFT EQU 499
IDM_BIND_RIGHT EQU 496
IDM_BIND_UP   EQU 495
IDM_BIND_DOWN EQU 503
IDM_BIND_X	  EQU 498
IDM_BIND_Y	  EQU 506
IDM_BIND_CENTRE EQU 119
IDM_BIND_OFFSET EQU 494
IDM_BIND_TFIND	EQU 493
IDM_BIND_NFIND	EQU 492
IDM_BIND_TDONE	EQU 491
IDM_BIND_ZOOMNORM EQU 490
IDM_BIND_ZOOMOUT  EQU 489
IDM_BIND_ZOOMIN   EQU 488
IDM_BIND_ZOOMX	  EQU 487
IDM_BIND_ORIGIN   EQU 486


;funcs in eve.asm...
ASMWNDPROC	PROTO	STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
wmdestroy	PROTO	STDCALL, :DWORD, :DWORD, :DWORD
wmrbuttondown	PROTO	STDCALL, :DWORD, :DWORD, :DWORD
wmlbuttonup 	PROTO	STDCALL, :DWORD, :DWORD, :DWORD
wmmousemove 	PROTO	STDCALL, :DWORD, :DWORD, :DWORD
wmsize		PROTO	STDCALL, :DWORD, :DWORD, :DWORD
wmcreate	PROTO	STDCALL, :DWORD, :DWORD, :DWORD
wmlbuttondown	PROTO	STDCALL, :DWORD, :DWORD, :DWORD
wmpaint 	PROTO	STDCALL, :DWORD, :DWORD, :DWORD
wmcommand	PROTO	STDCALL, :DWORD, :DWORD, :DWORD
savedatafile	PROTO	STDCALL
saveasdatafile	PROTO	STDCALL
selectedsaveasdatafile PROTO STDCALL
selectedsaveasemf PROTO STDCALL, :DWORD
opendatafile	PROTO	STDCALL
createnewobject   PROTO STDCALL, :DWORD
defaultnewnode	PROTO STDCALL, :DWORD
defaultnewcommand	PROTO STDCALL, :DWORD
defaultnewinfo	PROTO STDCALL, :DWORD
defaultneweve  PROTO STDCALL, :DWORD
defaultnewgeneric  PROTO STDCALL, :DWORD
defaultnewsound  PROTO STDCALL, :DWORD
defaultnewres	PROTO STDCALL, :DWORD
defaultnewlabel PROTO STDCALL, :DWORD	;*EVE*
defaultnewwire	PROTO STDCALL, :DWORD	;new execution-flow wire.
defaultnewgrid	PROTO STDCALL, :DWORD	;v1.28.
defaultnewwww	PROTO STDCALL, :DWORD	;v1.62.
defaultnewaxes	PROTO STDCALL, :DWORD	;v1.97.
add2wipeoutlist   PROTO STDCALL, :DWORD
add2updatelist	  PROTO STDCALL, :DWORD
add2highlightedlist   PROTO STDCALL, :DWORD
add2highlightedlist0  PROTO STDCALL, :DWORD
add2anilist 		  PROTO STDCALL, :DWORD ;v1.59
xuser		PROTO STDCALL, :DWORD, :DWORD, :DWORD
xuser1		PROTO STDCALL, :DWORD, :DWORD, :DWORD
xuser2		PROTO STDCALL, :DWORD, :DWORD, :DWORD
xuser4		PROTO STDCALL, :DWORD, :DWORD, :DWORD
xpaint_wipeout	PROTO STDCALL, :DWORD
xpaint_update	PROTO STDCALL, :DWORD
xpaint_entire	PROTO STDCALL, :DWORD
xpaint_extras	PROTO STDCALL, :DWORD
xpaint_print	PROTO STDCALL
TEXTOUTx  PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
isobjectinwindow PROTO STDCALL, :DWORD
origincorrection PROTO STDCALL, :DWORD
nearobjects 	 PROTO STDCALL, :DWORD
erasediagram	 PROTO STDCALL
opentemplate	 PROTO STDCALL
drawscrollbox	 PROTO STDCALL, :DWORD
scrollingbymouse	 PROTO STDCALL, :DWORD, :DWORD
displaymouse	 PROTO STDCALL, :DWORD, :DWORD
bin2dec 		 PROTO STDCALL, :DWORD
xtimer	PROTO STDCALL, :DWORD, :DWORD, :DWORD
xorigin 	 PROTO STDCALL
xdblclk 	PROTO STDCALL, :DWORD, :DWORD, :DWORD
bigmove 	 PROTO STDCALL
shoot		 PROTO STDCALL
openmerge	 PROTO STDCALL
str2longint  PROTO STDCALL, :DWORD
hexstr2longint	PROTO STDCALL, :DWORD ;v2.15.
onanobject	 PROTO STDCALL, :DWORD, :DWORD
xkeydown	PROTO STDCALL, :DWORD, :DWORD, :DWORD
xkeyup		PROTO STDCALL, :DWORD, :DWORD, :DWORD
updateslaves	 PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
wipeoutslaves	 PROTO STDCALL, :DWORD
deleteslaves	 PROTO STDCALL, :DWORD
fixwiremid	 PROTO STDCALL, :DWORD, :DWORD
fixnewchild  PROTO STDCALL, :DWORD, :DWORD
draw1starrow PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
draw2ndarrow PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
TESTDISPLAY  PROTO STDCALL, :DWORD
binto3dec	 PROTO STDCALL, :DWORD
insertring	 PROTO STDCALL, :DWORD, :DWORD
deletering	 PROTO STDCALL, :DWORD, :DWORD
openexternaleditor PROTO STDCALL, :DWORD, :DWORD, :DWORD
calcsig 	 PROTO STDCALL
;findmaster   PROTO STDCALL, :DWORD
;openadiagram PROTO STDCALL, :DWORD
checkintegrity PROTO STDCALL, :DWORD
duplicatehighlighted PROTO STDCALL, :DWORD
updateduplicates PROTO STDCALL
updatemove PROTO STDCALL
highlightinsiderect PROTO STDCALL
repositioncursor PROTO STDCALL, :DWORD
ishighlighted PROTO STDCALL, :DWORD
move1object PROTO STDCALL, :DWORD, :DWORD
clrmovedbit PROTO STDCALL
myprintersetup PROTO STDCALL
printeranalysis PROTO STDCALL, :DWORD
chooseacolor PROTO STDCALL, :DWORD, :DWORD
myerrorhandler PROTO STDCALL, :DWORD
comopen_closed_dlgbox PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
comclose_closed_dlgbox PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
bin2signedascii_upload PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
setcornersreadonly PROTO STDCALL, :DWORD, :DWORD
deleteelements PROTO STDCALL
duplicatedataelement PROTO STDCALL, :DWORD, :DWORD, :DWORD
ispointerok PROTO STDCALL, :DWORD
centralizeobj PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
calcdiagmidwindow PROTO STDCALL, :SDWORD
saveasembedded PROTO STDCALL
compress2file PROTO STDCALL, :DWORD, :DWORD, :DWORD
file2uncompress PROTO STDCALL, :DWORD, :DWORD
updateobjptrs PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
setupmemblock PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
insertbitmap PROTO STDCALL
choosebitmap PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
mygifload PROTO STDCALL, :DWORD, :DWORD, :DWORD
deletebitmaphandles PROTO STDCALL
creategifhdc PROTO STDCALL, :DWORD, :DWORD, :DWORD
calcxydiffnorm PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
addlocked2highlighted PROTO STDCALL, :DWORD
addcomposites2menu PROTO STDCALL, :DWORD
findcomposite PROTO, :DWORD, :DWORD
chooseafont PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
charsetname PROTO STDCALL, :DWORD
applycharset PROTO STDCALL
TFINDproc PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
NFINDproc PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
sendsignal2clip PROTO STDCALL
drawprintmargins	PROTO STDCALL, :DWORD
compactdatabase PROTO STDCALL
nliblimits		PROTO STDCALL, :DWORD
zeroabsoluteptrs PROTO STDCALL, :DWORD
newdatafile 	 PROTO STDCALL
findnextcategory PROTO STDCALL, :DWORD
deleteallcategorypopups PROTO STDCALL
isobjectinpage	 PROTO STDCALL, :DWORD
append2filemenu   PROTO STDCALL, :DWORD
prefs2new		  PROTO STDCALL
;stretchcompobj 	PROTO STDCALL, :DWORD,:DWORD,:DWORD
findnextattached  PROTO STDCALL, :DWORD
selectedsaveassvg PROTO STDCALL, :DWORD
composefill2buf 	  PROTO STDCALL
composestroke2buf	  PROTO STDCALL
composestrokewidth2buf PROTO STDCALL
grid_common_upload PROTO STDCALL, :DWORD
grid_common_download PROTO STDCALL, :DWORD
composeellipse		 PROTO STDCALL
composerect 		 PROTO STDCALL
composeparam2buf	   PROTO STDCALL, :DWORD, :DWORD, :DWORD
composepoly 		 PROTO STDCALL
composestickyline	 PROTO STDCALL
composeicon 		 PROTO STDCALL
exportbitmaps		 PROTO STDCALL, :DWORD
composetext 		 PROTO STDCALL
isactivatorattached  PROTO STDCALL, :DWORD, :DWORD, :DWORD
composeani			 PROTO STDCALL, :DWORD
wmrbuttonup 		 PROTO STDCALL
composepeall2buf	 PROTO STDCALL
displaynumber		 PROTO STDCALL, :DWORD
calcboundingrecthi	 PROTO STDCALL
onresizerect		 PROTO STDCALL, :DWORD, :DWORD
shadowhighlighted	 PROTO STDCALL
resizehighlighted	 PROTO STDCALL, :DWORD, :DWORD
copyhi2wipe 		 PROTO STDCALL
stretchhighlighted	 PROTO STDCALL, :DWORD,:DWORD,:DWORD
fixhighlightedlistptrs PROTO STDCALL, :DWORD
stoppedbit2hi		 PROTO STDCALL, :DWORD
copyhi2update		 PROTO STDCALL
insertsvg			 PROTO STDCALL
combinepolyarrays	 PROTO STDCALL
getpolypoints		 PROTO STDCALL, :DWORD
getpathpoints		 PROTO STDCALL, :DWORD
calcdatabasesize	 PROTO STDCALL
fliphighlighted 	 PROTO STDCALL, :DWORD
copyshadow2hi		 PROTO STDCALL
rot90hi 			 PROTO STDCALL
uncombinepolyarrays    PROTO STDCALL
insertspecialchars	 PROTO STDCALL
block2chain    PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
chain2block    PROTO STDCALL, :DWORD, :DWORD
stringcomparen PROTO STDCALL, :DWORD, :DWORD
htmltestendline PROTO STDCALL, :DWORD
htmlparsetag2nd PROTO STDCALL, :DWORD, :DWORD
htmlpaint1line  PROTO STDCALL, :DWORD, :DWORD
add2fontlist   PROTO STDCALL, :DWORD
paintlinewithfonts PROTO STDCALL, :DWORD
label_upload_common PROTO STDCALL, :DWORD
label_download_common PROTO STDCALL, :DWORD
findlinkactivator  PROTO STDCALL, :DWORD
upload_rgbcolor PROTO STDCALL, :DWORD, :DWORD, :DWORD
download_rgbcolor PROTO STDCALL, :DWORD, :DWORD, :DWORD
getgiftransparent PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
myalertbox PROTO STDCALL, :DWORD, :DWORD
parsegotolink PROTO STDCALL
lzp_compress  PROTO STDCALL, :DWORD, :DWORD, :DWORD
lzp_decompress PROTO STDCALL, :DWORD, :DWORD
file2uncompress_lzp PROTO STDCALL, :DWORD, :DWORD
painthandle    PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
onhandle       PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
paintgradientrect PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
brightencolor     PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
upload_morphing   PROTO STDCALL, :DWORD
download_morphing PROTO STDCALL, :DWORD
colortoggle_paint PROTO STDCALL, :DWORD
visibilitytoggle_paint PROTO STDCALL
loadcheckmarks    PROTO STDCALL, :DWORD
mycreatefont      PROTO STDCALL
download_font     PROTO STDCALL, :DWORD
label_download_fconfig4 PROTO STDCALL, :DWORD
disableelementsmenu PROTO STDCALL
calcrealsizehighlighted PROTO STDCALL

;eve2.asm
svgpaintlinewithfonts PROTO STDCALL, :DWORD, :DWORD
svghtmlcomposetext    PROTO STDCALL, :DWORD
svghtmlcomposepiece   PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
composelink           PROTO STDCALL
composelinkclose      PROTO STDCALL
svgcomposehi          PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
composepestroke2buf   PROTO STDCALL
composepenone2buf     PROTO STDCALL
composearc            PROTO STDCALL
composegotolink       PROTO STDCALL
composeinlinesvg      PROTO STDCALL, :DWORD
composeinsertsvgattribs PROTO STDCALL, :DWORD
isinlinesvgattached   PROTO STDCALL, :DWORD, :DWORD, :DWORD
composepaintgradientrect PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD

down_sendbackfront	 PROTO STDCALL, :DWORD, :DWORD, :DWORD	 ;common callback code.
down_owner			 PROTO STDCALL, :DWORD, :DWORD, :DWORD	 ;/
windowchanged		 PROTO STDCALL, :DWORD							 ;/
displaynumthis		 PROTO STDCALL, :DWORD					 ;/
down_lock			 PROTO STDCALL, :DWORD					 ;/
up_widthheight		 PROTO STDCALL, :DWORD					 ;/
down_widthheight	 PROTO STDCALL, :DWORD					 ;/

;this stuff needed to call methods...
displayPROTO TYPEDEF PROTO STDCALL, :DWORD, :DWORD	 ;pdisplay
displayPTR	 TYPEDEF PTR displayPROTO
dragPROTO	 TYPEDEF PROTO STDCALL, :DWORD		  ;pdrag
dragPTR 	 TYPEDEF PTR dragPROTO
deletePROTO   TYPEDEF PROTO STDCALL, :DWORD 	  ;pdelete
deletePTR		TYPEDEF PTR deletePROTO
onPROTO 	 TYPEDEF PROTO STDCALL, :DWORD, :DWORD, :DWORD	 ;ponobject
onPTR		 TYPEDEF PTR onPROTO
wipePROTO	 TYPEDEF PROTO STDCALL, :DWORD	;pwipeslaves
wipePTR 	 TYPEDEF PTR wipePROTO
snapPROTO	TYPEDEF PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD ;psnap
snapPTR 	TYPEDEF PTR snapPROTO

;prototypes for the methods...
paint_node	  PROTO STDCALL, :DWORD, :DWORD  ;*EVE*
;paint_res	   PROTO STDCALL, :DWORD, :DWORD
paint_arc	 PROTO STDCALL, :DWORD, :DWORD ;*EVE*
;paint_comp    PROTO STDCALL, :DWORD, :DWORD
;paint_super   PROTO STDCALL, :DWORD, :DWORD
;paint_jb	   PROTO STDCALL, :DWORD, :DWORD
;paint_cmt	   PROTO STDCALL, :DWORD, :DWORD
;paint_sub	   PROTO STDCALL, :DWORD, :DWORD
;paint_comp    PROTO STDCALL, :DWORD, :DWORD
;paint_att	   PROTO STDCALL, :DWORD, :DWORD
;paint_fnc	   PROTO STDCALL, :DWORD, :DWORD
;paint_exec    PROTO STDCALL, :DWORD, :DWORD
paint_info	  PROTO STDCALL, :DWORD, :DWORD
paint_grid	   PROTO STDCALL, :DWORD, :DWORD
paint_ani	   PROTO STDCALL, :DWORD, :DWORD ;v1.59
;paint_make   PROTO STDCALL, :DWORD, :DWORD
;delete_node	PROTO STDCALL, :DWORD
;delete_icon	PROTO STDCALL, :DWORD
;delete_res PROTO STDCALL, :DWORD
delete_any	PROTO STDCALL, :DWORD ;*EVE*
;delete_arc PROTO STDCALL, :DWORD ;*EVE*
;delete_jb	 PROTO STDCALL, :DWORD
;delete_at	 PROTO STDCALL, :DWORD
;delete_sub  PROTO STDCALL, :DWORD
;delete_fnc  PROTO STDCALL, :DWORD
drag_node	PROTO STDCALL, :DWORD ;*EVE*
drag_arc	PROTO STDCALL, :DWORD ;*EVE*
drag_poly PROTO STDCALL, :DWORD ;*EVE*
;drag_super  PROTO STDCALL, :DWORD
;drag_sub	 PROTO STDCALL, :DWORD
on_node PROTO STDCALL, :DWORD, :DWORD, :DWORD	;*EVE*
on_cmt	PROTO STDCALL, :DWORD, :DWORD, :DWORD	;*EVE*
on_res	PROTO STDCALL, :DWORD, :DWORD, :DWORD
on_arc		PROTO STDCALL, :DWORD, :DWORD, :DWORD	;*EVE*
;on_super	PROTO STDCALL, :DWORD, :DWORD, :DWORD
;on_fnc PROTO STDCALL, :DWORD, :DWORD, :DWORD
on_any		PROTO STDCALL, :DWORD, :DWORD, :DWORD
on_poly 	PROTO STDCALL, :DWORD, :DWORD, :DWORD ;*EVE*
on_axes 	PROTO STDCALL, :DWORD, :DWORD, :DWORD
wipeslaves_node PROTO STDCALL, :DWORD ;*EVE*
wipeslaves_gen	PROTO STDCALL, :DWORD ;*EVE*
snap_tonode PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
snap_tores	PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
snap_gen	PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
;snap_toany  PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD ;*EVE* also _toarc
snap_topoly PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD


GIF_INFO		STRUCT
	lpGIFData		dd	?				; Pointer to the GIF File data
	dwGIFDataSize	dd	?				; Size of GIF Data
GIF_INFO		ENDS




;------------------------------------
;c functions called from asm...


;public variables in eve.asm, accessable from goosee_c.c...
;PUBLIC instantiatedOBJECT, instantiatedTERSEDATA;
PUBLIC pTERSEDATA
PUBLIC highlightedindex
PUBLIC n1stx		;selection rectangle.
PUBLIC n1sty		;/
PUBLIC n2ndx		;/
PUBLIC n2ndy		;/



;NOTES
;
;PAINTING
;--------
;To display or print an object, the calls go like this:
;WM_PAINT msg --> wmpaint() --> xpaint_entire/update/wipeout/print()
; --> paint_node/*etc*.
;Different size fonts are created in wmpaint()
;a font is assigned, a brush and/or pen is created & assigned, before
;calling each display method.
;paint_node/etc() are the methods. A change from oldgoofee, is I
;want to avoid creating and assigning fonts/brushes/pens inside these.
;
;NEW OBJECT
;----------
;From the menu, select an object, say IDM_NODE. Must be state=0.
;IDM_NODE --> createnewobject() --> defaultnewnode() --> state=4,
;g_pmovingobject pts to new node.
;createnewobject() creates a generic object.
;defaultnewnode() sets up the fields of OBJECT structure appropriate
;for a node.
;wmmousemove() tests state, if =4, displays new object, tracking the
;mouse.

;SUMMARY OF STATES:
;-----------------
;0		normal
;1		newly-selected object						 must come from 0.
;2		highlighted object							 must come from 1
;4		new object from menu, being placed. 		 must come from 0
;5		new object from menu, other-end being placed.must come from 4
;8	moving object (also wire ends)			 must come from 1 (or 2)

;20 drawing a selection-rectangle, 1st corner
;21 "	2nd corner.
;22

;30 v1.92 dragging side of a resize rectangle.

;In states 4,5 & 8, the object is identified by pmovingobject (& pmoving).
;in state 1, object is identified by g_pselectedobjnew.
;in state 2, object is identified by g_pselectedobject.
;in state 0, rbuttondown on an object is identified by rbuttonobject.
;...i'm now allowing right-click on a highlighted element (state2).

;v1.43 thinking about composite-objects...
;when left-click on any element of a comp-obj, g_pselectedobject --> "boss" element,
;the elements of the object do *not* get added to highlightedlist at this stage.
;the drag_() methods take care of dragging all elements of the comp-obj.

;FONT TYPES
;----------
;On date 12-1-00 I changed the standard size font used in the diagram
;to Times New Roman. This scales up and down better than the previous
; MS Serif, which is non-TrueType.
;However, Times New Roman displays slightly lower. I've gone thru and
;shifted everything up 1 pixel. and marked it "12-1-00" so can go back
;quickly if it needs changing again.


