#To run this Make file...
#  NMAKE /A EVEX.MAK
# what I'm doing here is assembling a file eve.asm, with
# a resource file eve.rc, generating executable eve.exe.
# the masm switches "/c /coff" generate COFF debugging info.
# the link switches "/DEBUG /DEBUGTYPE:COFF" generate
# debugging info in COFF format, inside the EXE file.

# Sept.2002 for compatibility with MS Codeview, use "/c /coff /Zi"
# /c means assemble without linking.
# /coff means generate object file in coff format.
# /Zi means generate symbolic debug info.
# for MASM and "debug:full" and "debugtype:cv" for the linker.

fn = eve
#masmsw = /c /coff
masmsw = /c /coff

all:$(fn).EXE

$(fn).OBJ : $(fn).ASM
 ..\masm32\bin\ML $(masmsw) $(fn).ASM

$(fn).RES : $(fn).RC
 ..\masm32\bin\RC $(fn).RC

$(fn).EXE : $(fn).OBJ $(fn).RES
 ..\masm32\bin\LINK @<<LinkFile
/MACHINE:i386
/SUBSYSTEM:WINDOWS,4.0
/ENTRY:start
/MAP:$(fn).map
/OUT:$(fn).exe
/DEBUG:FULL
/DEBUGTYPE:COFF
$(fn).obj
$(fn).res
..\masm32\lib\USER32.LIB
..\masm32\lib\KERNEL32.LIB
..\masm32\lib\GDI32.LIB
..\masm32\lib\COMDLG32.LIB
..\masm32\lib\COMCTL32.LIB
..\masm32\lib\winmm.lib
..\masm32\lib\ole32.lib
..\masm32\lib\olepro32.lib
..\masm32\lib\shell32.lib
<<NOKEEP

